javax.enterprise.inject.spi

## Interface ProcessInjectionTarget<X>

- Type Parameters:
    `X` - The managed bean class, session bean class or Java EE component class supporting injection

      public interface ProcessInjectionTarget<X>

  The container fires an event of this type for every Java EE component class supporting injection that may be instantiated by the container at runtime, including every managed bean declared using `javax.annotation.ManagedBean`, EJB session or message-driven bean, enabled bean, enabled interceptor or enabled decorator.

  Any observer of this event is permitted to wrap and/or replace the `InjectionTarget`. The container must use the final value of this property, after all observers have been called, whenever it performs injection upon the managed bean, session bean or other Java EE component class supporting injection.

  For example, this observer decorates the `InjectionTarget` for all servlets.

       public <T extends Servlet> void decorateServlet(@Observes ProcessInjectionTarget<T> pit) {
           pit.setInjectionTarget(decorate(pit.getInjectionTarget()));
       }

  If any observer method of a `ProcessInjectionTarget` event throws an exception, the exception is treated as a definition error by the container.

  Author:
    David Allen
  See Also:
    `InjectionTarget`

- - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `addDefinitionError(Throwable t)` Registers a definition error with the container, causing the container to abort deployment after bean discovery is complete.
    `AnnotatedType<X>` | `getAnnotatedType()` Returns the `AnnotatedType` representing the managed bean class, session bean class or other Java EE component class supporting injection.
    `InjectionTarget<X>` | `getInjectionTarget()` Returns the `InjectionTarget` object that will be used by the container to perform injection.
    `void` | `setInjectionTarget(InjectionTarget<X> injectionTarget)` Replaces the `InjectionTarget` which performs injection for this target.

- - ### Method Detail

    - #### getAnnotatedType

          AnnotatedType<X> getAnnotatedType()

      Returns the `AnnotatedType` representing the managed bean class, session bean class or other Java EE component class supporting injection.
      Returns:
        the `AnnotatedType` of the bean with an injection target
      Throws:
        `IllegalStateException` - if called outside of the observer method invocation

    - #### getInjectionTarget

          InjectionTarget<X> getInjectionTarget()

      Returns the `InjectionTarget` object that will be used by the container to perform injection.
      Returns:
        the `InjectionTarget` object which performs the injection
      Throws:
        `IllegalStateException` - if called outside of the observer method invocation

    - #### setInjectionTarget

          void setInjectionTarget(InjectionTarget<X> injectionTarget)

      Replaces the `InjectionTarget` which performs injection for this target.
      Parameters:
        `injectionTarget` - The new `InjectionTarget` to use
      Throws:
        `IllegalStateException` - if called outside of the observer method invocation

    - #### addDefinitionError

          void addDefinitionError(Throwable t)

      Registers a definition error with the container, causing the container to abort deployment after bean discovery is complete.
      Parameters:
        `t` - A `Throwable` representing the definition error
      Throws:
        `IllegalStateException` - if called outside of the observer method invocation

Copyright © 1996-2013, Oracle and/or its affiliates. All Rights Reserved. Use is subject to license terms.